#include <vcl.h>                
#pragma hdrstop
#include "PhysikEingabe.h"
#pragma link "Dialogfenster"
#pragma link "UserEditor"
#pragma resource "PhysikEingabe.res"
#pragma package(smart_init)




static inline void ValidCtrCheck(KPhysikEingabe*)
{
  new KPhysikEingabe(NULL);
}

__fastcall KPhysikEingabe::KPhysikEingabe(TComponent* Owner)
 : TWinControl(Owner)
{
// ShowMessage("Konstruktor");
  //FComboPhysik=new TComboPhysik(this);
  FUserWerte = new KUserValues();
  FStringUserWerte = new KString();
  FStringUserWerte->s=
  "SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***SI-Einheit***1***";
  FDblSpin=new TCDoubleSpinEdit(this);
  FDblSpin->Parent=this;
  FComboPhysik=new KPhysikCombo_II(this);  // KPhsyikCombo NICHT TComboPhysik
  FComboPhysik->Style=Stdctrls::csDropDownList;
  FComboPhysik->Parent=this;
  FDblSpin->FSpinCombo=FComboPhysik;
  FComboPhysik->OnChange=ComboChange;
  FDblSpin->OnChange=SpinEditChange;
  FDblSpin->OnTastenDruck=TastenDruck;
  FDblSpin->OnKeyDruck=KeyPress;
  FDblSpin->OnEscapePressed=EscPress;     // um bei Drcken von Esc-Taste
  FComboPhysik->OnKeyDown=CheckEsc;      // Wert zurckzusetzen
  Height=21;
  Width=150;
  FRatio=0.55;
  FDblSpin->Left=0;
  FDblSpin->Top=0;
  FDblSpin->Width= Width*FRatio-5;
  FComboPhysik->Left=FDblSpin->Width+10;
  FComboPhysik->Top=0;
  FComboPhysik->Width= Width*(1-FRatio)-5;
  Combo_Visible=true;
  Edit_Visible=true;
}

void __fastcall KPhysikEingabe::Hide_Combo(bool t)
     {
     FComboPhysik->Visible=t;
     FCombo_Visible=t;
     }

void __fastcall KPhysikEingabe::Hide_Edit(bool t)
     {
     FDblSpin->Visible=t;
     FEdit_Visible=t;
     }


void __fastcall KPhysikEingabe::TastenDruck(TObject* Sender)
{
 if(FOnTastenDruck)
   FOnTastenDruck(this);
 //FDblSpin->KeyPress(Key);
}

void __fastcall KPhysikEingabe::KeyPress(TObject* Sender, Char& Key)
{
 if(FOnKeyPress)
  FOnKeyPress(this,Key);
}

/*
void __fastcall KPhysikEingabe::SetUserWerte(KUserValues* uservalue)
{
 for(int i=0;i<10;i++)
 {
  FUserWerte->EinheitenMatrix[i]=uservalue->EinheitenMatrix[i];
  FUserWerte->UmrechnungsMatrix[i]=uservalue->UmrechnungsMatrix[i];
 }
 SetEinheiten(User_defined);
 ShowMessage("SetUserWerte");
}
*/
void __fastcall KPhysikEingabe::SetUserWerte(KString* val)
{
 FUserWerte=new KUserValues(val->s);
// ShowMessage("SetUserWerte");
}

void __fastcall KPhysikEingabe::WMSize(TWMSize &Message)
{
   Hide_Combo(FCombo_Visible);

   FDblSpin->Left=0;
   FDblSpin->Top=0;
   FDblSpin->Width= Width*FRatio-5;
   FComboPhysik->Left=FDblSpin->Width+10;
   FComboPhysik->Top=0;
   FComboPhysik->Width= Width*(1-FRatio)-5;
   Height=21;



 // FDblSpin->Height=Height;
 // FComboPhysik->Height=Height;
}

void __fastcall KPhysikEingabe::SetRatio(double ratio)
{
  if(ratio<0.5) ratio=0.5;
  if(ratio>0.9) ratio=0.9;
  FRatio=ratio;
  // wie oben wird nun die Komponente neu gezeichnet
  FDblSpin->Left=0;
  FDblSpin->Top=0;
  FDblSpin->Width= Width*FRatio-5;
  FComboPhysik->Left=FDblSpin->Width+10;
  FComboPhysik->Top=0;
  FComboPhysik->Width= Width*(1-FRatio)-5;
}

void __fastcall KPhysikEingabe::CreateWnd()
{
  TWinControl::CreateWnd();
//  SetEinheiten(Masse_pro_Zeit);
  SetEinheiten(Laenge);
  FComboPhysik->AuswahlIndex=0;
  FSIWert=FComboPhysik->umrechnen(FDblSpin->Value);
  SIIncrement=FComboPhysik->umrechnen(FDblSpin->Increment);
}

void KPhysikEingabe::DoEntering()
{
  if(FOnEntering)
   FOnEntering(this);
  value_on_focus=SIWert;
}

void KPhysikEingabe::DoExiting()
{
  if(FOnExiting)
   FOnExiting(this);
  if(value_on_focus!=SIWert)
    DoChanged();
}

void KPhysikEingabe::DoChange()
{
  if(FOnChange)
   FOnChange(this);
}

void KPhysikEingabe::DoChanged()
{
  if(FOnChanged)
   FOnChanged(this);
}


void __fastcall KPhysikEingabe::ComboChange(TObject* Sender)
{
 // ShowMessage("ComboChange");
  if(SofortUmrechnen)
  {    // angezeigten Wert ndern , SIWert unverndert
   FDblSpin->Value=FComboPhysik->umrechnenVonSI(FSIWert);
   }
  else //nicht sofort umrechnen
  {   // angezeigter Wert unverndert, SI-Wert ndern
   FSIWert=FComboPhysik->umrechnen(FDblSpin->Value);
  }
  // Increment ndern
  if(Einheiten!=Temperatur && Einheiten!=Eins_pro_Temperatur)
  {
    FDblSpin->Increment=FComboPhysik->umrechnenVonSI(SIIncrement);
  }
  //ShowMessage("AuswahlIndex= "+FloatToStr(FComboPhysik->UmrechnungsFaktor));
  DoChange();
}

void __fastcall KPhysikEingabe::SpinEditChange(TObject* Sender)
{
  //ShowMessage("SpinChange");
  FSIWert=FComboPhysik->umrechnen(FDblSpin->Value);
  DoChange();
  //ShowMessage("Change Value= "+FloatToStr(FSIWert));
}

void __fastcall KPhysikEingabe::EscPress(TObject* Sender)
{
  Value=FFocusValue;
  FComboPhysik->AuswahlIndex=FFocusItem;
  SpinEditChange(this);
}

void __fastcall KPhysikEingabe::CheckEsc(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
//    ShowMessage("CheckEsc");           //Onkeydown    nur hinten (Combo)
  if(Key==VK_ESCAPE)
  {
    Value=FFocusValue;
    FComboPhysik->AuswahlIndex=FFocusItem;
    SpinEditChange(this);
  }
}

void __fastcall KPhysikEingabe::SetReadOnly(bool NewValue)
{
 FReadOnly=NewValue;
 FDblSpin->ReadOnly=NewValue;
}

bool __fastcall KPhysikEingabe::GetReadOnly(void)
{
 return FReadOnly;
}

void __fastcall KPhysikEingabe::SetIncrement(double NewValue)
{
  FDblSpin->Increment=NewValue;
  if(Einheiten!=Temperatur)
    SIIncrement=FComboPhysik->umrechnen(FDblSpin->Increment);
}

double __fastcall KPhysikEingabe::GetIncrement(void)
{
  return FDblSpin->Increment;
}

void __fastcall KPhysikEingabe::SetMaxValue(double NewValue)
{
  FDblSpin->MaxValue=NewValue;
}

void __fastcall KPhysikEingabe::Benutzer_Einheit(AnsiString SI_Einheit)
{
  FComboPhysik->User_defined(SI_Einheit);
}
void __fastcall KPhysikEingabe::Benutzer_Einheit_Hinzu(AnsiString Einheit, double Umrechnung)
{
  FComboPhysik->Add_User_defined(Einheit, Umrechnung);
}

double __fastcall KPhysikEingabe::GetMaxValue(void)
{
  return FDblSpin->MaxValue;
}
void __fastcall KPhysikEingabe::SetMinValue(double NewValue)
{
  FDblSpin->MinValue=NewValue;
}

double __fastcall KPhysikEingabe::GetMinValue(void)
{
  return FDblSpin->MinValue;
}

void __fastcall KPhysikEingabe::SetValue(double NewValue)
{
  FDblSpin->Value=NewValue;
  FSIWert=FComboPhysik->umrechnen(NewValue);
}

void __fastcall KPhysikEingabe::SetzeSIWert(double NewValue)
{
  FSIWert=NewValue;
  Value=FComboPhysik->umrechnenVonSI(NewValue);
}

double __fastcall KPhysikEingabe::GetValue(void)
{
  return FDblSpin->Value;
}


AnsiString __fastcall KPhysikEingabe::GetEEinheit(void)
{
   return FComboPhysik->Items->Strings[FComboPhysik->AuswahlIndex];
}

void __fastcall KPhysikEingabe::SetEEinheit(AnsiString aString)
{
   if(Einheiten==User_defined)
   {
     if(FUserWerte->EinheitenMatrix[1]=="SI-Einheit") // keine Eintrge
       return;
     else   // falls doch Eintrge
     {
          int i=FComboPhysik->Items->IndexOf(aString); // Einheit suchen
          if(i!=-1) // falls gefunden:
          {
                FComboPhysik->AuswahlIndex=i; // Einheit setzen
                     if(SofortUmrechnen)
                        {     // SIWert in neue Einheit umrechnen und Value zuweisen:
                               Value=FComboPhysik->umrechnenVonSI(FSIWert); //SIWert wird durch  Aufruf
                        }                                             // von Value gesetzt!!!
                     else     // falls nicht sofort umgerechnet wird:
                        FSIWert=FComboPhysik->umrechnen(Value); // Value+neueEinheheit nach SI
                                                // umrechnen
          }
          else  // i=-1
                throw EInvalidEinheit("Die angegebene Einheit existiert nicht");
     }                 // Ende Eintrge vorhanden

   }   // Ende User-defined
   else // falls nicht User-defined
   {
   int i=FComboPhysik->Items->IndexOf(aString); // Einheit suchen
   if(i!=-1) // falls gefunden:
    {
     FComboPhysik->AuswahlIndex=i; // Einheit setzen
     if(SofortUmrechnen)
      {     // SIWert in neue Einheit umrechnen und Value zuweisen:
       Value=FComboPhysik->umrechnenVonSI(FSIWert); //SIWert wird durch  Aufruf
      }                                             // von Value gesetzt!!!
     else     // falls nicht sofort umgerechnet wird:
       FSIWert=FComboPhysik->umrechnen(Value); // Value+neueEinheheit nach SI
                                                // umrechnen
    }
   else
     throw EInvalidEinheit("Die angegebene Einheit existiert nicht");
   } // Ende nicht user-defined
}



void __fastcall KPhysikEingabe::CMEnter(TWMNoParams &Message)
{
  FFocusValue=Value;      //bei Focuserhalt: Wert merken
  FFocusItem=FComboPhysik->AuswahlIndex;
  DoEntering();
  //ShowMessage("CMENTER");
}

void __fastcall KPhysikEingabe::CMExit(TWMNoParams &Message)
{
  //Application->MessageBox("Exit","Exit",MB_OK);
  if (CheckValue (Value) != Value)
    //SetValue (Value);
   {
     //ShowMessage("CheckValue!=Value wie folgt");
     //ShowMessage((AnsiString)CheckValue(Value));
     //ShowMessage((AnsiString)Value);

     AnsiString Ansage="Der Wert liegt nicht im Intervall von\n";
     Ansage+=AnsiString(MinValue)+" "+FDblSpin->FSpinCombo->Items->Strings[0];
     Ansage+=" bis " + AnsiString(MaxValue)+" "+FDblSpin->FSpinCombo->Items->Strings[0];
     Application->MessageBox(Ansage.c_str(),"Meldung",MB_OK);
     FDblSpin->SetFocus();
   }
   DoExiting();
}

double __fastcall KPhysikEingabe::CheckValue(double NewValue)
{
   //ShowMessage("CheckValue");
  double Result;
  Result = FDblSpin->FSpinCombo->umrechnen(NewValue); // in SI-Wert umrechnen
  //Result=NewValue;
  if (FDblSpin->MaxValue != FDblSpin->MinValue) {
 // ShowMessage("Max!=Min wie folgt:");
 // ShowMessage((AnsiString) FDblSpin->MaxValue);
 // ShowMessage((AnsiString) FDblSpin->MinValue);
    if (Result < FDblSpin->MinValue)
      Result = FDblSpin->MinValue;
    else if (Result > FDblSpin->MaxValue)
      Result = FDblSpin->MaxValue;
  }
  else
   return NewValue;
  return FDblSpin->FSpinCombo->umrechnenVonSI(Result); // zurckrechnen

}
/*
void __fastcall KPhysikEingabe::SetTabOrder(short order)
{
 FDblSpin->TabOrder=order;
}

short __fastcall KPhysikEingabe::GetTabOrder(void)
{
 return FDblSpin->TabOrder;
}

void __fastcall KPhysikEingabe::SetTabStop(bool tabstop)
{
 FDblSpin->TabStop=tabstop;
}

bool __fastcall KPhysikEingabe::GetTabStop(void)
{
 return FDblSpin->TabStop;
}
*/

Einheit __fastcall KPhysikEingabe::GetEinheiten(void)
{
  return FComboPhysik->Einheiten;
}

void __fastcall KPhysikEingabe::SetEinheiten(Einheit aEinheiten)
{
  FComboPhysik->Einheiten=aEinheiten;


  //Items loeschen
  FComboPhysik->Items->Clear();
//  for (int m=0;m<FComboPhysik->Items->Count;m++)
//  FComboPhysik->Items->Add(FComboPhysik->Items->Strings[0]);

  switch(FComboPhysik->FEinheiten){    // bzw. Einheiten


    case Kraft_pro_Flaeche: {
       //Items und Matrix neu setzen
       FComboPhysik->Items->Add("N/m^2");           //0
       FComboPhysik->FUmrechnungsMatrix[0]=1;    //0

       FComboPhysik->Items->Add("N/mm^2");                   //1
       FComboPhysik->FUmrechnungsMatrix[1]=(double) 1000000.;  //1

       FComboPhysik->Items->Add("kN/mm^2");                       //2
       FComboPhysik->FUmrechnungsMatrix[2]=(double) 1000.;    //2

       break;
       }


     case  keine_Einheit: {
       //Items und Matrix neu setzen
       FComboPhysik->Items->Add("-");           //0
       FComboPhysik->FUmrechnungsMatrix[0]=1;    //0
       break;
       }


    case Kraft: {
       //Items und Matrix neu setzen
       FComboPhysik->Items->Add("N");           //0
       FComboPhysik->FUmrechnungsMatrix[0]=1;    //0

       FComboPhysik->Items->Add("kN");                   //1
       FComboPhysik->FUmrechnungsMatrix[1]=(double) 1000.;  //1

       FComboPhysik->Items->Add("MN");                       //2
       FComboPhysik->FUmrechnungsMatrix[2]=(double) 1000000.;    //2

       break;
       }


    case Masse_pro_Zeit: {
       //Items und Matrix neu setzen
       FComboPhysik->Items->Add("kg/s");           //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;    //0

       FComboPhysik->Items->Add("kg/min");                   //1
       FComboPhysik->FUmrechnungsMatrix[1]=(double) 1./60.;  //1

       FComboPhysik->Items->Add("kg/h");                       //2
       FComboPhysik->FUmrechnungsMatrix[2]=(double) 1./3600.;    //2

       FComboPhysik->Items->Add("g/s");                      //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e-3;                //3

       FComboPhysik->Items->Add("g/min");                    //4
       FComboPhysik->FUmrechnungsMatrix[4]=(double) (1.e-3)/60.;    //4

       FComboPhysik->Items->Add("g/h");                      //5
       FComboPhysik->FUmrechnungsMatrix[5]=(double) (1.e-3)/3600.; //5

       break;
       }

    case Energie_pro_Masse_und_Temperatur: {
      // wie oben

       FComboPhysik->Items->Add("J/kgK");          //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;   //0

       FComboPhysik->Items->Add("J/gK");            //1
       FComboPhysik->FUmrechnungsMatrix[1]=1.e3;      //1

       FComboPhysik->Items->Add("J/mgK");           //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e6;      //2

       FComboPhysik->Items->Add("kJ/kgK");         //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e3;      //3

       FComboPhysik->Items->Add("kJ/gK");          //4
       FComboPhysik->FUmrechnungsMatrix[4]=1.e6;     //4

       FComboPhysik->Items->Add("kJ/mgK");         //5
       FComboPhysik->FUmrechnungsMatrix[5]=1.e9;    //5

       break;
       }



    case Leistung_pro_Masse_und_Temperatur: {
      // wie oben

       FComboPhysik->Items->Add("W/kgK");          //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;   //0

       FComboPhysik->Items->Add("W/gK");            //1
       FComboPhysik->FUmrechnungsMatrix[1]=1.e3;      //1

       FComboPhysik->Items->Add("W/mgK");           //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e6;      //2

       FComboPhysik->Items->Add("kW/kgK");         //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e3;      //3

       FComboPhysik->Items->Add("kW/gK");          //4
       FComboPhysik->FUmrechnungsMatrix[4]=1.e6;     //4

       FComboPhysik->Items->Add("kW/mgK");         //5
       FComboPhysik->FUmrechnungsMatrix[5]=1.e9;    //5

       break;
       }

      case Leistung_pro_Laenge_und_Temperatur: {

       FComboPhysik->Items->Add("W/mK");          //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;   //0

       FComboPhysik->Items->Add("W/mmK");            //1
       FComboPhysik->FUmrechnungsMatrix[1]=1.e3;      //1

       FComboPhysik->Items->Add("kW/mK");           //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e-3;      //2

       FComboPhysik->Items->Add("kW/mmK");         //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.;      //3

       break;
       }

      case Leistung_pro_Flaeche: {

       FComboPhysik->Items->Add("W/m2");          //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;   //0

       FComboPhysik->Items->Add("W/mm2");            //1
       FComboPhysik->FUmrechnungsMatrix[1]=1.e6;      //1

       FComboPhysik->Items->Add("kW/m2");           //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e-3;      //2

       FComboPhysik->Items->Add("kW/mm2");         //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e3;      //3

       break;
      }

    case Masse_pro_Volumen: {

       FComboPhysik->Items->Add("kg/m");         //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;    //0

       FComboPhysik->Items->Add("kg/dm");          //1
       FComboPhysik->FUmrechnungsMatrix[1]=1.e3;      //1

       FComboPhysik->Items->Add("kg/cm");        //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e6;    //2

       FComboPhysik->Items->Add("kg/mm");        //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e9;   //3

       FComboPhysik->Items->Add("g/m");          //4
       FComboPhysik->FUmrechnungsMatrix[4]=1.e-3;      //4

       FComboPhysik->Items->Add("g/dm");         //5
       FComboPhysik->FUmrechnungsMatrix[5]=1.;    //5

       FComboPhysik->Items->Add("g/cm");         //6
       FComboPhysik->FUmrechnungsMatrix[6]=1.e3;    //6

       FComboPhysik->Items->Add("g/mm");         //7
       FComboPhysik->FUmrechnungsMatrix[7]=1.e6;    //7

       break;
       }

    case Laenge_pro_Zeit: {
       FComboPhysik->Items->Add("m/s");              //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;        //0

       FComboPhysik->Items->Add("dm/s");              //1
       FComboPhysik->FUmrechnungsMatrix[1]=0.1;       //1

       FComboPhysik->Items->Add("cm/s");              //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e-2;      //2

       FComboPhysik->Items->Add("mm/s");              //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e-3;      //3

       FComboPhysik->Items->Add("km/s");              //4
       FComboPhysik->FUmrechnungsMatrix[4]=1.e3;       //4

       FComboPhysik->Items->Add("m/h");                       //5
       FComboPhysik->FUmrechnungsMatrix[5]=(double) 1./3600.;   //5

       FComboPhysik->Items->Add("m/min");                    //6
       FComboPhysik->FUmrechnungsMatrix[6]=(double) 1./60.;    //6

       break;
       }

    case Laenge: {
       FComboPhysik->Items->Add("m");              //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;      //0

       FComboPhysik->Items->Add("dm");              //1
       FComboPhysik->FUmrechnungsMatrix[1]=0.1;     //1

       FComboPhysik->Items->Add("cm");              //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e-2;    //2

       FComboPhysik->Items->Add("mm");              //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e-3;    //3

       FComboPhysik->Items->Add("um");              //3
       FComboPhysik->FUmrechnungsMatrix[4]=1.e-6;    //3

       FComboPhysik->Items->Add("nm");              //3
       FComboPhysik->FUmrechnungsMatrix[5]=1.e-9;    //3

       FComboPhysik->Items->Add("km");              //4
       FComboPhysik->FUmrechnungsMatrix[6]=1.e3;     //4

       break;
       }

    case Zeit: {
       FComboPhysik->Items->Add("s");                //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;        //0

       FComboPhysik->Items->Add("min");              //1
       FComboPhysik->FUmrechnungsMatrix[1]=60.;       //1

       FComboPhysik->Items->Add("h");                 //2
       FComboPhysik->FUmrechnungsMatrix[2]=3600.;      //2

       FComboPhysik->Items->Add("ms");                //3
       FComboPhysik->FUmrechnungsMatrix[3]=1.e-3;      //3

       break;
       }



    case Masse: {
       FComboPhysik->Items->Add("kg");                //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;       //0

       FComboPhysik->Items->Add("g");                //1
       FComboPhysik->FUmrechnungsMatrix[1]=1.e-3;        //1

       FComboPhysik->Items->Add("mg");               //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e-6;     //2

       break;
       }

    case Volumen_pro_Zeit: {
       FComboPhysik->Items->Add("m/s");            //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;        //0

       FComboPhysik->Items->Add("m/min");                  //1
       FComboPhysik->FUmrechnungsMatrix[1]=(double) 1./60.;    //1

       FComboPhysik->Items->Add("m/h");                    //2
       FComboPhysik->FUmrechnungsMatrix[2]=(double) 1./3600.;  //2

       FComboPhysik->Items->Add("dm/s");            //3
       FComboPhysik->FUmrechnungsMatrix[3]=1e-3;      //3

       FComboPhysik->Items->Add("dm/min");                         //4
       FComboPhysik->FUmrechnungsMatrix[4]=(double) (1.e-3)/60.;        //4

       FComboPhysik->Items->Add("dm/h");                           //5
       FComboPhysik->FUmrechnungsMatrix[5]=(double) (1.e-3)/3600.;     //5

       FComboPhysik->Items->Add("cm/s");                //6
       FComboPhysik->FUmrechnungsMatrix[6]=1e-6;          //6

       FComboPhysik->Items->Add("cm/min");                         //7
       FComboPhysik->FUmrechnungsMatrix[7]=(double) (1.e-6)/60.;       //7

       FComboPhysik->Items->Add("cm/h");                               //8
       FComboPhysik->FUmrechnungsMatrix[8]=(double) (1.e-6)/3600.;        //8

       FComboPhysik->Items->Add("mm/s");              //9
       FComboPhysik->FUmrechnungsMatrix[9]=1e-9;        //9

       FComboPhysik->Items->Add("mm/min");                         //10
       FComboPhysik->FUmrechnungsMatrix[10]=(double) (1.e-9)/60.;      //10

       FComboPhysik->Items->Add("mm/h");                           //11
       FComboPhysik->FUmrechnungsMatrix[11]=(double) (1.e-9)/3600.;    //11

       break;
       }

    case Druck: {
       FComboPhysik->Items->Add("Pa");               //0
       FComboPhysik->FUmrechnungsMatrix[0]=1.;        //0

       FComboPhysik->Items->Add("bar");              //1
       FComboPhysik->FUmrechnungsMatrix[1]=1.e5;      //1

       FComboPhysik->Items->Add("mbar");             //2
       FComboPhysik->FUmrechnungsMatrix[2]=1.e2;      //2

       break;
       }

    case Energie_pro_Stoffmenge: {
        FComboPhysik->Items->Add("J/mol");            //0
        FComboPhysik->FUmrechnungsMatrix[0]=1.;        //0

        FComboPhysik->Items->Add("kJ/mol");            //1
        FComboPhysik->FUmrechnungsMatrix[1]=1000.;      //1

        FComboPhysik->Items->Add("kJ/kmol");          //2
        FComboPhysik->FUmrechnungsMatrix[2]=1.;         //2

        FComboPhysik->Items->Add("J/kmol");           //3
        FComboPhysik->FUmrechnungsMatrix[3]=1.E-3;     //3

        break;
        }

    case Energie_pro_Masse: {
        FComboPhysik->Items->Add("J/g");            //0
        FComboPhysik->FUmrechnungsMatrix[0]=1000.;        //0

        FComboPhysik->Items->Add("kJ/g");            //1
        FComboPhysik->FUmrechnungsMatrix[1]=1000000.;      //1

        FComboPhysik->Items->Add("J/kg");          //2
        FComboPhysik->FUmrechnungsMatrix[2]=1.;         //2

        FComboPhysik->Items->Add("kJ/kg");           //3
        FComboPhysik->FUmrechnungsMatrix[3]=1000.;     //3

        break;
        }


    case Anteil_Prozent: {
        FComboPhysik->Items->Add("Anteil");           //0
        FComboPhysik->FUmrechnungsMatrix[0]=1;        //0

        FComboPhysik->Items->Add("Prozent");          //1
        FComboPhysik->FUmrechnungsMatrix[1]=1E-2;     //1

        FComboPhysik->Items->Add("Promille");         //2
        FComboPhysik->FUmrechnungsMatrix[2]=1E-3;     //2

        FComboPhysik->Items->Add("ppm");              //3
        FComboPhysik->FUmrechnungsMatrix[3]=1E-6;     //3

        break;
        }

    case User_defined: {
        FComboPhysik->Items->Add(FUserWerte->EinheitenMatrix[0]);
        FComboPhysik->FUmrechnungsMatrix[0]=1;
        for(int i=1;i<10;i++)
        {
          if(FUserWerte->EinheitenMatrix[i]!="SI-Einheit")
          {
            FComboPhysik->Items->Add(FUserWerte->EinheitenMatrix[i]);
            FComboPhysik->FUmrechnungsMatrix[i]=FUserWerte->UmrechnungsMatrix[i];
          }
        }

        break;
        }

    case Temperatur: {
       FComboPhysik->Items->Add("K");                //0
       FComboPhysik->FUmrechnungsMatrix[0]=1;        //0

       FComboPhysik->Items->Add("C");               //1
       FComboPhysik->FUmrechnungsMatrix[1]=273.15;    //1

       FComboPhysik->Items->Add("F");               //2
       FComboPhysik->FUmrechnungsMatrix[2]=273.15;    //2

       break;
       }

       case Eins_pro_Temperatur: {
       FComboPhysik->Items->Add("1/K");                //0
       FComboPhysik->FUmrechnungsMatrix[0]=1;        //0

       FComboPhysik->Items->Add("1/C");               //1
       FComboPhysik->FUmrechnungsMatrix[1]=273.15;    //1

       FComboPhysik->Items->Add("1/F");               //2
       FComboPhysik->FUmrechnungsMatrix[2]=273.15;    //2

       break;
       }

    }


    //UmrechnungsFaktor und ersten Eintrag als ausgewhltes Element setzen

   FComboPhysik->FUmrechnungsFaktor=FComboPhysik->FUmrechnungsMatrix[0];
  FComboPhysik->AuswahlIndex=0;

}

namespace Physikeingabe
{

  void __fastcall PACKAGE Register()
  {
    TComponentClass classes[1] = {__classid(KPhysikEingabe)};
    RegisterComponents("Klaus", classes, 0);
    RegisterPropertyEditor( __typeinfo(KString),__classid(KPhysikEingabe),
                "UserWerte",__classid(KUserEditor) );

  }

}


